#ifndef DLGSTRUCT_H
#define DLGSTRUCT_H

typedef struct {
  unsigned char type,unknown1,x,y;
  int dataoffset;
  unsigned char lbutton,rbutton,unknown2,unknown3,unknown4,unknown5;
} DlgTitleStruct;

typedef struct {
  int noofobjects;
  unsigned char width,height;
  int (*UserFunc)(int, long);
} DlgHeaderStruct;

typedef struct {
  unsigned char type,unknown1,x,y;
} DlgObjectHeaderStruct;

typedef struct {
  unsigned int type;
  unsigned char x,y;
  unsigned int offset,bufferoffset;
  unsigned char various1,various2,various3,various4;
} DlgObject;

#define offset(from,to) asm(" .word " #to "-" #from)

/**************
* POPUP MENUS *
**************/
#define BEGIN_POPUP(name,data,totalnoofobjects,noofmainobjects,height) \
  unsigned int name ## [0] = {}; \
  asm(" .word " #data "-" #name); \
  unsigned int name ## _header[4] = {0x00d5,totalnoofobjects,height,noofmainobjects}; \
  asm(" .word " #name ## "_end - " #name); \
  unsigned char name ## _data[8] = {0,0,0,0,0xff,0xff,0xff,0xff};

#define ADD_POPUP_TEXT(name,structdata,textdata,ret_val) \
  char name[2] = {0x80,ret_val}; \
  asm(" .word " #textdata "-" #structdata);

#define ADD_POPUP_MENU(name,structdata,textdata,root,menu,ret_val) \
  char name[2] = {0xc0,ret_val}; \
  asm(" .word " #textdata "-" #structdata "," #menu "-" #root);

#define BEGIN_POPUP_MENU(name) \
  unsigned int name[0] = {};
#define END_POPUP_MENU \
  asm(" .byte 0xff,0xff,0xff,0xff");

#define END_POPUP(name) \
  asm(#name ## "_end:");

/***************
* DIALOG BOXES *
***************/
#define BEGIN_DIALOG(name,data,noofobjects,width,height,callbackfunction) \
  unsigned int name ## [0] = {}; \
  asm(" .word " #data "-" #name); \
  DlgHeaderStruct name ## _header = {noofobjects,width,height,callbackfunction};

#define ADD_DIALOG_TEXT(name,structdata,textdata,x,y) \
  char name ## [4] = {7,128,x,y}; \
  asm(" .word " #textdata "-" #structdata); \
  char name ## _data[6] = {0,0,0,0,0,0};

#define ADD_DIALOG_TITLE(name,structdata,textdata,leftbutton,rightbutton) \
  char name ## [4] = {8,128,0,0}; \
  asm(" .word " #textdata "-" #structdata); \
  char name ## _data[6] = {leftbutton,rightbutton,0,0,0,0};

#define ADD_DIALOG_REQUEST(name,structdata,textdata,x,y,characters,width,bufferoffset) \
  char name ## [4] = {2,0,x,y}; \
  asm(" .word " #textdata "-" #structdata); \
  int name ## _bufferoffset = bufferoffset; \
  char name ## _data[4] = {0,characters,width,0};

#define ADD_DIALOG_POPUP(name,structdata,textdata,x,y,menu,ret_val) \
  char name ## [4] = {0x0a,2,x,y}; \
  asm(" .word " #textdata "-" #structdata); \
  void *name ## _menu = & ## menu; \
  int name ## _retval = ret_val;

#define END_DIALOG(name) \
  char name ## _end[12] = {0,0,0,0,0,0,0,0,0,0,0,0};

#endif
